protected/controllers/UserController.php
<?php

class UserController extends Controller {
    const PAGE_SIZE = 10;
    /**
     * @var string specifies the default action
     */
    public $defaultAction='admin';

    /**
     * @var CActiveRecord the currently loaded data model instance.
     */
    private $_user;

    /**
     * @return array action filters
     */
    public function filters() {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    /**
     * Specifies the access control rules.
     * This method is used by the 'accessControl' filter.
     * @return array access control rules
     */
    public function accessRules() {
        return array(
            array('allow',  # all users
                'actions'=>array(
                    'create', 'confirm', 'welcome',
                    'sendActivationEmail', 'emailWelcome'),
                'users'=>array('*'),
            ),
            array('allow', # logged in users
                    'actions'=>array('welcome', 'activationNeeded', 'changePassword','view_profile','edit_profile'),
                    'users'=>array('@'),
                ),
            array('allow', # admins
                'actions'=>array('list', 'show', 'delete','admin','update','view','newsletter'),
                'roles'=>array('admin'),
            ),
            array('deny',  // deny all users
                'users'=>array('*'),
            ),
        );
    }

    /**
     * Shows a particular user.
     */
    public function actionShow() {
        #if (Yii::app()->user->checkAccess('showUser')) {
        #}
        $this->render('show',array('user'=>$this->loadUser()));
    }

    # Create new account
    public function actionCreate() {
        $user = new User;
        $user->newsletter=false;
        $this->performAjaxValidation($user);
        if (isset($_POST['User'])) {
            //$user->attributes = $_POST['User'];
            $user->setScenario('insert');
            $attrs = $_POST['User'];
            $user->attributes=$attrs;
            $user->email = strtolower(trim($attrs['email']));
            $user->username = $user->email;
            $user->first_name = trim($attrs['first_name']);
            $user->last_name = trim($attrs['last_name']);
            $user->password = $attrs['password'];
            $user->password_repeat = $attrs['password_repeat'];
            $user->first_name=$attrs['first_name'];
            $user->last_name=$attrs['last_name'];
            $user->affiliation = $attrs['affiliation'];
            $user->preferred_link = $attrs['preferred_link'];

            if (!Yii::app()->user->checkAccess('admin')) {
                $user->role = 'user'; // avoid send POST hacking
            }
            $user->newsletter=$attrs['newsletter'];
            $user->previous_newsletter_state = !$user->newsletter;

            if (in_array($_SERVER['GIGADB_ENV'], ["dev","CI"]) && "testCaptcha" !== $attrs['verifyCode']) {
                Yii::log("Because we are on {$_SERVER['GIGADB_ENV']}, captcha value is overridden for automated acceptance test", 'warning');
                Yii::log("To exercise captcha validation, use 'testCaptcha' in the form", 'warning');
                $_SESSION["captcha"] = $attrs['verifyCode'];
            }

            if ($user->validate('insert')) {
                $user->encryptPassword();

                if ($user->save(false)) {
                    $this->sendActivationEmail($user);
                    if($user->newsletter)
                        Yii::app()->newsletter->addToMailing($user->email);

                    $this->redirect(array('welcome', 'id'=>$user->id));
                }
                else {
                    Yii::log(__FUNCTION__."> create failed", 'warning');
                }
            }
            else {
                Yii::log(__FUNCTION__."> validation failed", 'warning');
            }
        }
        $this->render('create', array('model'=>$user)) ;
    }

    protected function performAjaxValidation($model) {
        if (isset($_POST['ajax']) && $_POST['ajax']==='user-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

    /**
     * Updates a particular user.
     * If update is successful, the browser will be redirected to the 'show' page.
     */
    public function actionUpdate() {
        $user = $this->loadUser();
        $this->performAjaxValidation($user);
        #if (!Yii::app()->user->checkAccess('updateOwnUser', array('user'=>$user))) {
        #    Yii::log(__FUNCTION__."> Unauthorized", 'debug');
        #    throw new CHttpException(403, 'You are not authorized to perform this action.');
        #}




        if (isset($_POST['User'])) {
            $user->attributes = $_POST['User'] ;
            $attrs = $_POST['User'];

            $password = $user->password_new = $attrs['password'];
            $user->password_repeat = $attrs['password_repeat'];

            if (!Yii::app()->user->checkAccess('admin')) {
                $user->role = 'user';
            }

            if ($user->validate('update')) {
                if ($password != '') {
                    $user->encryptPassword();
                }

                if ($user->save(false)) {

                    Yii::app()->user->setFlash('notice', 'Updated');
                    $this->redirect(array('user/show/id/'.$user->id));
                }
                else {
                    Yii::log(__FUNCTION__."> Update failed", 'warning');
                }

            }
            else {
                Yii::log(__FUNCTION__."> validation failed", 'warning');
            }
        }
        $user->password = $user->password_repeat = '';
        $this->render('update', array('model'=>$user));

    }

    /**
     * Deletes a particular user.
     * If deletion is successful, the browser will be redirected to the 'list' page.
     */
    public function actionDelete() {
        if (Yii::app()->request->isPostRequest) {
            # we only allow deletion via POST request
            $user =User::model()->findbyPk($_GET['id']) ;
            $auth = Yii::app()->authManager;
            $auth->revoke($user->getRole(), $user->email);
            //$user->delete();

            $user->is_activated = False;
            if ($user->save(False))
                $this->redirect(array('admin'));
            else{
                Yii::log("Saving user error" . print_r($user->getErrors(), true), 'error');
            }

        }
        else {
            throw new CHttpException(500,'Invalid request. Please do not repeat this request again.');
        }
    }

    /**
     * Lists all users.
     */
    public function actionList() {
        $criteria = new CDbCriteria;

        $pages = new CPagination(User::model()->count($criteria));
        $pages->pageSize = self::PAGE_SIZE;
        $pages->applyLimit($criteria);

        $sort = new CSort('User');
        $sort->applyOrder($criteria);

        $userList = User::model()->findAll($criteria);

        $this->render('list',array(
            'userList'=>$userList,
            'pages'=>$pages,
            'sort'=>$sort,
        ));
    }

    /**
     * Manages all users.
     */
    public function actionAdmin() {
        $model=new User('search');
        $model->unsetAttributes();  // clear any default values
        if(isset($_GET['User']))
            $model->setAttributes($_GET['User']);

        $this->loadBaBbqPolyfills = true;
        $this->render('admin',array(
            'model'=>$model,
        ));
    }

    public function actionNewsletter(){

     $result = User::model()->findAllBySql("select email,first_name, last_name, affiliation from gigadb_user where newsletter=true order by id;");


     $this->renderPartial('newsletter',array(
            'models'=>$result,
        ));


    }

    # Confirm email works
	public function actionConfirm() {
		$key = $_GET['key'] ;
		User::model()->updateAll(array('is_activated'=>1),'id=:unique_id', array(':unique_id'=>$key));

        $user = User::model()->findByAttributes(array('id' => $key));
        if ($user->is_activated) {
            $this->sendNotificationEmail($user);
        }

		$this->render('confirm', array('user'=>$user));
	}

    public function actionWelcome() {
        $this->render('welcome', array('user'=>$this->loadUser())) ;
    }

    public function actionActivationNeeded() {
        $this->render('activationNeeded', array('user'=>$this->loadUser())) ;
    }

    public function actionView_Profile() {
        $model = new EditProfileForm();
        $model->user_id = Yii::app()->user->id;

        $user = $this->loadUser(Yii::app()->user->id);
        $model->first_name = $user->first_name;
        $model->last_name = $user->last_name;
        $model->email = $user->email;
        $model->affiliation = $user->affiliation;
        $model->newsletter = $user->newsletter;
        $model->preferred_link = $user->preferred_link;

        $current = $user->newsletter;

        if (isset($_POST['EditProfileForm'])) {
            $model->attributes = $_POST['EditProfileForm'];

            if ($model->validate()) {
                if($model->updateInfo()) {
                    $new = $model->newsletter;
                    if($new && !$current) {
                        Yii::log('add new mailing', 'debug');
                        $success = Yii::app()->newsletter->addToMailing($model->email, $model->first_name, $model->last_name);
                    }
                    if(!$new && $current) {
                        Yii::log('remove mailing', 'debug');
                        $success = Yii::app()->newsletter->removeFromMailing($model->email);
                    }
                    $this->redirect('/user/view_profile');
                }
            } else {
                Yii::log(print_r($model->getErrors(), true), 'debug');
            }
        }

protected/views/user/_form.php
 <div class="content col-md-offset-2 col-md-8">

 	<?php
		foreach (Yii::app()->user->getFlashes() as $key => $message) {
			echo '<div class="flash-' . $key . '">' . $message . "</div>\n";
		}
		?>
 	<?php
		$user_command = UserCommand::model()->findByAttributes(array("requester_id" => $model->id, "status" => "pending"));
		$linked_author = $model->id ? Author::findAttachedAuthorByUserId($model->id) : null;

		?>

 	<?php
		if (!$model->isNewRecord) {
			if (null != $user_command) {
				echo CHtml::openTag('div', array('class' => 'subsection'));
				$claimed_author = Author::model()->findByPk($user_command->actionable_id);
				$message = "This user has a pending claim on author " . $claimed_author->getDisplayName();
				$validate_link = CHtml::link(
					'Validate',
					array('AdminUserCommand/validate', 'id' => $user_command->id),
					array('class' => 'btn background-btn')
				);
				$reject_link = CHtml::link(
					'Reject',
					array('AdminUserCommand/reject', 'id' => $user_command->id),
					array('class' => 'btn background-btn-o')
				);
				$author_link = CHtml::link(
					'Author info',
					array('AdminAuthor/view', 'id' => $user_command->actionable_id),
					array('class' => 'btn background-btn-o')
				);
				echo CHtml::closeTag('div');
		?>
 			<div class="alert alert-gigadb-info">
 				<div class="mb-10">
 					<? echo $message ?>
 				</div>
 				<div class="btn-toolbar">
 					<? echo $validate_link ?>
 					<? echo $reject_link ?>
 					<? echo $author_link ?>
 				</div>
 			</div>

 		<?php
			} else if (null ==  $linked_author) {
				echo CHtml::openTag('div', array('class' => 'mb-10'));
				echo CHtml::link(
					'Link this user to an author',
					array('adminAuthor/prepareUserLink', 'user_id' => $model->id),
					array('class' => 'btn background-btn')
				);
				echo CHtml::closeTag('div');
			} else {
				echo CHtml::openTag('div', array('class' => 'mb-10'));
				$unlink_link =  CHtml::link(
					'Unlink author',
					array('AdminAuthor/unlinkUser', 'id' => $linked_author->id, 'user_id' => $model->id),
					array('class' => 'btn background-btn')
				);
				echo CHtml::closeTag('div');
			?>
 			<div class="alert alert-gigadb-info">
 				<div class="mb-10">
 					This user is linked to author: <? echo $linked_author->getDisplayName() ?> (<? echo $linked_author->id ?>)
 				</div>
 				<div class="btn-toolbar">
 					<? echo $unlink_link ?>
 				</div>
 			</div>
 	<?php
			}
		}
		?>

 	<div>
 		<div class="subsection">
 			<?php
				$isAdmin = Yii::app()->user->checkAccess('manageUsers');
				if ($model->isNewRecord && !$isAdmin) { ?>
 				<p><?= Yii::t('app', 'GigaScience appreciates your interest in the GigaDB project. With a GigaDB account, you can submit new datasets to the database. Also, GigaDB can automatically notify you of new content which matches your interests. Please fill out the following information and register to enjoy the benefits of GigaDB membership!') ?></p>
        <p class="mb-10">For more information or assistance, please contact us at: <a href="mailto:database@gigasciencejournal.com" target="_blank">database@gigasciencejournal.com</a>.</p>
 			<? }
				?>
 			<?php Yii::app()->captcha->generate(); ?>
 			<div class="well">
 				<? $form = $this->beginWidget('CActiveForm', array(
						'id' => 'user-form',
						'enableAjaxValidation' => false,
						'htmlOptions' => array('class' => 'form-horizontal create-user-form')
					)) ?>

 				<p class="mb-10" aria-hidden="true">Fields with <span class="symbol">*</span> are required.</p>

         <?php if ($model->hasErrors()) : ?>
            <div class="alert alert-danger">
                <?php echo $form->errorSummary($model); ?>
            </div>
        <?php endif; ?>

        <?php
          CHtml::$afterRequiredLabel = '<span aria-hidden="true"> *</span>';
        ?>

 				<?php
					$this->widget('application.components.controls.TextField', [
						'form' => $form,
						'model' => $model,
						'labelOptions' => [
							'class' => 'col-xs-3',
						],
						'inputWrapperOptions' => 'col-xs-9',
						'attributeName' => 'email',
						'inputOptions' => [
							'required' => 'required',
						],
					]);
					$this->widget('application.components.controls.TextField', [
						'form' => $form,
						'model' => $model,
						'labelOptions' => [
							'class' => 'col-xs-3',
						],
						'inputWrapperOptions' => 'col-xs-9',
						'attributeName' => 'first_name',
						'inputOptions' => [
							'required' => 'required',
						],
					]);
					$this->widget('application.components.controls.TextField', [
						'form' => $form,
						'model' => $model,
						'labelOptions' => [
							'class' => 'col-xs-3',
						],
						'inputWrapperOptions' => 'col-xs-9',
						'attributeName' => 'last_name',
						'inputOptions' => [
							'required' => 'required',
						],
					]);
					$this->widget('application.components.controls.PasswordField', [
						'form' => $form,
						'model' => $model,
						'labelOptions' => [
							'class' => 'col-xs-3',
						],
						'inputWrapperOptions' => 'col-xs-9',
						'attributeName' => 'password',
						'inputOptions' => [
							'required' => 'required',
						],
					]);
					$this->widget('application.components.controls.PasswordField', [
						'form' => $form,
						'model' => $model,
						'labelOptions' => [
							'class' => 'col-xs-3',
						],
						'inputWrapperOptions' => 'col-xs-9',
						'attributeName' => 'password_repeat',
						'inputOptions' => [
							'required' => 'required',
						],
					]);
					?>


 				<? if (Yii::app()->user->checkAccess('admin')) { ?>
 					<div class="form-group">
 						<?= $form->labelEx($model, 'role', array('class' => 'col-xs-3 control-label')) ?>
 						<div class="col-xs-9">
 							<?= $form->dropDownList($model, 'role', array('user' => 'user', 'admin' => 'admin'), array('class' => 'form-control', 'aria-describedby' => $model->hasErrors('role') ? 'role-error' : '')) ?>
 							<div id="role-error"><?= $form->error($model, 'role', array('class' => 'control-error help-block')) ?></div>
 						</div>
 					</div>
 				<? } ?>
 				<?php
					$this->widget('application.components.controls.TextField', [
						'form' => $form,
						'model' => $model,
						'labelOptions' => [
							'class' => 'col-xs-3',
						],
						'inputWrapperOptions' => 'col-xs-9',
						'attributeName' => 'affiliation',
						'inputOptions' => [
							'required' => 'required',
						],
					]);
					?>
 				<div class="form-group">
 					<?= $form->labelEx($model, 'preferred_link', array('class' => 'col-xs-3 control-label')) ?>
 					<div class="col-xs-9">
 						<?= CHtml::activeDropDownList($model, 'preferred_link', User::$linkouts, array('class' => 'form-control', 'aria-describedby' => $model->hasErrors('preferred_link') ? 'preferred_link-error' : '')) ?>
 						<div id="preferred_link-error"><?= $form->error($model, 'preferred_link', array('class' => 'control-error help-block')) ?></div>
 					</div>
 				</div>
 				<div class="form-group checkbox-horizontal">
 					<label class="col-xs-3 control-label" for="User_newsletter"><?= Yii::t('app', 'Mailing list') ?></label>
 					<div class="col-xs-9">
 						<?php echo $form->checkbox($model, 'newsletter', array('aria-describedby' => 'newsletter-desc')); ?>
 					</div>
 					<div class="col-xs-9" id="newsletter-desc">
 						<p>Please tick here to join the GigaDB mailing list to receive news, updates and quarterly newsletters about GigaDB</p>
 					</div>
 				</div>
 				<div class="form-group checkbox-horizontal <?= $model->hasErrors('terms') ? 'has-error' : '' ?>">
 					<?= $form->labelEx($model, 'terms', array('class' => 'col-xs-3 control-label')) ?>
 					<div class="col-xs-9">
 						<?php echo $form->checkbox($model, 'terms', array('aria-describedby' => $model->hasErrors('terms') ? 'terms-error terms-desc' : 'terms-desc', 'required' => true, 'aria-required' => 'true')); ?>
 						<div id="terms-error"><?= $form->error($model, 'terms', array('class' => 'control-error help-block')) ?></div>
 						<p id="terms-desc" class="help-block">Please tick here to confirm you have read and understood our <a href="/site/term#policies">Terms of use</a> and <a href="/site/term#privacy">Privacy Policy</a></p>
 					</div>
 				</div>



 				<? if ($model->isNewRecord) { ?>
 					<div class="form-group">
 						<?php echo $form->labelEx($model, 'verifyCode', array('class' => 'col-xs-3 control-label')); ?>
 						<div class="col-xs-9">
 							<div style="width:100%">
 								<img style="width:200px;" src="<?php echo Yii::app()->captcha->output(); ?>" alt="Type the word in the image">
 							</div>
 							<br>
 							<br>
 							<?php echo $form->textField($model, 'verifyCode', array('class' => 'form-control', 'aria-describedby' => $model->hasErrors('verifyCode') ? 'verifyCode-error verifyCode-desc' : 'verifyCode-desc')); ?>
 							<div id="verifyCode-desc" class="hint control-description help-block">Please enter the letters as they are shown in the image above.
 								<br />Letters are case-sensitive.
 							</div>
 							<div id="verifyCode-error">
 								<?php echo $form->error($model, 'verifyCode', array('class' => 'control-error help-block')); ?>
 							</div>
 						</div>
 					</div>
 				<? } ?>
 				<hr>
 				<div class="pull-right">
 					<?= CHtml::submitButton($model->isNewRecord ? Yii::t('app', 'Register') : 'Save', array('class' => 'btn background-btn submit-btn')) ?>
 				</div>
 				<div class="clearfix"></div>
 				<? $this->endWidget() ?>
 			</div><!--well-->



 			<?php
				$path = "images/tempcaptcha/" . $text . ".png";
				$files = glob('images/tempcaptcha/*');
				foreach ($files as $file) {
					if (is_file($file))
						if ($file != $path)
							unlink($file);
				}
				?>
 		</div>
 	</div><!-- user-form -->
 </div>

protected/views/user/activationNeeded.php
<?php $this->pageTitle = Yii::app()->name . ' - Welcome' ?>

<h2><?=Yii::t('app' , 'Account Activation')?></h2>
<div class="clear"></div>

<div class="yiiForm">
<p><?=Yii::t('app' , 'An account activation email has been emailed to your email address.')?></p>
<p><?=Yii::t('app' , 'If you don\'t receive the email within a few minutes, please check your spam filters.')?> <br/>
<?=Yii::t('app' , 'Click')?> <?= CHtml::link(Yii::t('app' ,"here"), array("user/sendActivationEmail", 'id'=>$user->id)) ?> <?=Yii::t('app' , 'to resend the email')?>
<?=Yii::t('app' , 'or') ?> <?= CHtml::link(Yii::t('app' ,"contact us"), "mailto:" . Yii::app()->params['support_email']) ?>&nbsp;
<?=Yii::t('app' , 'and we will get it sorted.')?>
</p>
</div><!-- yiiForm -->

protected/views/user/admin.php
<div class="container">
  <?php
  $this->widget('TitleBreadcrumb', [
    'pageTitle' => 'Manage Users',
    'breadcrumbItems' => [
      ['label' => 'Admin', 'href' => '/site/admin'],
      ['isActive' => true, 'label' => 'Users'],
    ]
  ]);
  ?>
  <p>
    To list certain news items that you are looking for, you may search via keyword or value. Type your keyword or value into their respective boxes under the column headers and press the enter key. You may optionally enter a comparison operator (<b>&lt;</b>, <b>&lt;=</b>, <b>&gt;</b>, <b>&gt;=</b>, <b>&lt;&gt;</b>
    or <b>=</b>) at the beginning of each of your search values to specify how the comparison should be done.
  </p>

<?php
Yii::app()->clientScript->registerScript('customize-close-button', '
  $(document).on("dialogopen", "#controls", function(event, ui) {
    var closeButton = $(".ui-dialog-titlebar-close", $(this).parent());
    closeButton.html("<i class=\'fa fa-close fa-lg\'></i>");
    closeButton.attr("aria-label", "Close Dialog");
  });
');
?>

<?php $this->beginWidget('zii.widgets.jui.CJuiDialog', array(
  'id' => 'controls',
  // additional javascript options for the dialog plugin
  'options' => array(
    'title' => 'Managing User',
    'autoOpen' => false,
    'modal' => true,
  ),
));

?>

<h2 class="h5">Basic Operations</h2>
<div class="btns-row">
  <button class="btn background-btn-o" title="view" onclick="goto_userview();">View</button>
  <button class="btn background-btn-o" title="update" onclick="goto_userupdate();">Update</button>
  <button class="btn danger-btn-o delete" title="delete" onclick="goto_userdelete();">Delete</button>
</div>

<h2 class="h5">Advanced Operations</h2>
<button class="btn background-btn-o" title="link" onclick="goto_userlinkauthor();">Link this user to an author</button>


<div id="status" class="mt-10"></div>

<?
$this->endWidget('zii.widgets.jui.CJuiDialog');
?>

<?php $this->widget('CustomGridView', array(
  'id' => 'news-grid',
  'dataProvider' => $model->search(),
  'filter' => $model, // turn on/off filtering
  'rowHtmlOptionsExpression' => 'array("data-userid" => $data->id)',
  'itemsCssClass' => 'table table-bordered dataset-table-wide',
  'template' => '<div class="dataset-table-wide-container">{items}</div>{pager}',
  'selectionChanged' => "function(id){open_controls($.fn.yiiGridView.getSelection(id));}",
  'columns' => array(
    'id',
    'email',
    'first_name',
    'last_name',
    'role',
    array(
      'name' => 'affiliation',
      'headerHtmlOptions' => array('style' => 'min-width:150px;'),
    ),
    'facebook_id',
    'twitter_id',
    'linkedin_id',
    'google_id',
    'username',
    array(
      'name' => 'is_activated',
      'value' => '($data->is_activated) ? "Yes" : "No"'
    ),
    array(
      'name' => 'newsletter',
      'value' => '$data->renderNewsletter()',
    ),
    array(
      'class' => 'CButtonColumn',
      'header' => "Actions",
      'headerHtmlOptions' => array('style' => 'min-width: 120px'),
      'template' => '{view}{update}{manage}{delete}',
      'buttons' => array(
        'view' => array(
            'imageUrl' => false,
            'label' => '',
            'options' => array(
                "title" => "View",
                "class" => "fa fa-eye fa-lg icon icon-view",
                "aria-label" => "View"
            ),
        ),
        'update' => array(
            'imageUrl' => false,
            'label' => '',
            'options' => array(
                "title" => "Update",
                "class" => "fa fa-pencil fa-lg icon icon-update",
                "aria-label" => "Update"
            ),
        ),
        'delete' => array(
            'imageUrl' => false,
            'label' => '',
            'options' => array(
                "title" => "Delete",
                "class" => "fa fa-trash fa-lg icon icon-delete",
                "aria-label" => "Delete"
            ),
        ),
        'manage' => array(
          'imageUrl' => false,
        'label' => '',
        'options' => array(
            "title" => "Merge authors",
            "class" => "fa fa-wrench fa-lg icon icon-manage",
            "aria-label" => "Merge authors",
            "role" => "button",
        ),
        "click" => "handleManageClick"
        )
    ),
    )
  ),
)); ?>

</div>


<script>
  function handleManageClick(e) {
    const userId = String($(e.target).closest('tr').attr('data-userid'));
    open_controls(userId)
  }

  function open_controls(user_id) {
    console.log(user_id)
    $("#controls").data('user_id', user_id);
    $("#controls").dialog("option", "title", "Manage User Id: " + user_id);
    $("#controls").dialog("open");
    return false;
  }

  function goto_userview() {
    <?
    echo 'var userview_url = "' . Yii::app()->urlManager->createUrl('user/view', array('id' => '')) . '";'
    ?>
    var user_id = $("#controls").data('user_id');
    window.location = userview_url + "/" + user_id;
  }

  function goto_userview() {
    <?
    echo 'var base_url = "' . Yii::app()->urlManager->createUrl('user/view', array('id' => '')) . '";'
    ?>
    var user_id = $("#controls").data('user_id');
    window.location = userview_url + "/" + user_id;
  }

  function goto_userview() {
    <?
    echo 'var base_url = "' . Yii::app()->urlManager->createUrl('user/view', array('id' => '')) . '";'
    ?>
    var user_id = $("#controls").data('user_id');
    window.location = base_url + "/" + user_id;
  }

  function goto_userupdate() {
    <?
    echo 'var base_url = "' . Yii::app()->urlManager->createUrl('user/update', array('id' => '')) . '";'
    ?>
    var user_id = $("#controls").data('user_id');
    window.location = base_url + "/" + user_id;
  }

  function goto_userdelete() {
    <?
    echo 'var base_url = "' . Yii::app()->urlManager->createUrl('user/delete', array('id' => '')) . '";'
    ?>
    var user_id = $("#controls").data('user_id');
    //window.location= base_url + "/" + user_id;
    $.ajax({
      url: base_url + "/" + user_id,
      type: 'POST',
      success: function(data) {
        $("#status").addClass("alert alert-success")
          .append("user successfully deactivated.")
          .append("Refresh the page to see the changes.");
      },
      error: function(data) {
        $("#status").addClass("alert alert-danger")
          .append("user deactivation failed.")
      }
    });
  }

  function goto_userlinkauthor() {
    <?
    echo 'var base_url = "' . Yii::app()->urlManager->createUrl('adminAuthor/prepareUserLink', array('user_id' => '')) . '";'
    ?>
    var user_id = $("#controls").data('user_id');
    window.location = base_url + "/" + user_id;
  }
</script>

protected/views/user/confirm.php
<? if ($user->is_activated) { ?>
<h3>Your account has been activated</h3>

<p><?= CHtml::link("Log in", array('site/login')) ?> to configure your account.</p>
<? } else { ?>
<h3>Account Pending</h3>

You are now registered. We will contact you shortly. Feel free to
or <?= CHtml::link("contact us", "mailto:" . Yii::app()->params['support_email']) ?>&nbsp;
if you prefer.</p>
<? } ?>

protected/views/user/list.php
<h2>User List</h2>

<div class="actionBar">
[<?= CHtml::link('New User',array('create')); ?>]
[<?= CHtml::link('Manage User',array('admin')); ?>]
</div>

<?php $this->widget('CLinkPager',array('pages'=>$pages)); ?>

<div class="item">
<?php foreach($userList as $n=>$model): ?>
<?= CHtml::encode($model->id); ?>:
<?= CHtml::link($model->email,array('show', 'id'=>$model->id)); ?>
 (<?= CHtml::encode($model->email); ?>)
 (<strong><?= CHtml::encode($model->getRole()); ?></strong>)
<br/>

<?php endforeach; ?>
</div>
<br/>
<?php $this->widget('CLinkPager',array('pages'=>$pages)); ?>

protected/views/user/newsletter.php
<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
echo "Email"."||"."First_name"."||"."Last_name"."||"."Affiliation";
?>
<br>
   <? 
   
foreach ($models as $model) {

    echo $model->email."||".$model->first_name."||".$model->last_name."||".$model->affiliation;
    ?>
<br>
   <? 
}
?>

protected/views/user/searches.php
<section>

	<table class="table table-bordered saved-table text-center">
		<thead>
			<tr>
            	<th colspan="9"><?= Yii::t('app', 'Your Saved Search') ?></th>
        	</tr>
			<tr>
				<th>
					Keyword
				</th>
				<th>
					Result
				</th>
			</tr>
		</thead>
		<tbody>
			<?php foreach($searchRecord as $sr) { ?>
				<tr>
					<td><?= $sr->name ?></td>
					<?/*
					<td><?= $sr->resultDetail ?></td>
					*/?>
					<td>
						<a href="<?= $sr->searchPage ?>" class="btn">View Result</a>
					</td>
				</tr>
			<?php } ?>
		</tbody>
	</table>

</section>